//           TorrentInfoTab.cc
//  Fri Aug 31 22:14:27 2007
//  Copyright  2007  Fernando Tarín Morales
//  icemanf@gmail.com

// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 3 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Library General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 51 Franklin Street, Fifth Floor Boston, MA 02110-1301,  USA

 
#include "TorrentInfoTab.h"
#include "NoteBookManager.h"

#include <iostream>

TorrentInfoTab::TorrentInfoTab():
	infoNoteBook(this),
	BaseTab()
{
	shortName = torrentName = "info";
	setLabel(torrentName);
}

TorrentInfoTab::TorrentInfoTab(const Glib::ustring & tName, const libtorrent::sha1_hash & sh, NoteBookManager *_nb):
	infoNoteBook(this),
	BaseTab()
{
	torrentName = tName;
	torrentHash = sh;
	if (torrentName.size() > 12){
		shortName.assign(torrentName, 0, 12);
		shortName.assign(torrentName, 0, 11);
		shortName += "...";
		setLabel(shortName);
	}
	else
		setLabel(torrentName);
	
	nb = _nb;
}

TorrentInfoTab::TorrentInfoTab(const TorrentInfoTab& t):
	infoNoteBook(this),
	BaseTab()
{
	nb = t.nb;
	torrentName = t.torrentName;
	torrentHash = t.torrentHash;
	if (torrentName.size() > 12){
		shortName.assign(torrentName, 0, 12);
		shortName += "...";
		setLabel(shortName);
	}
	else
		setLabel(torrentName);
}

TorrentInfoTab& TorrentInfoTab::operator=(const TorrentInfoTab &t){
	if (this !=  &t){
		nb = t.nb;
		torrentName = t.torrentName;
		torrentHash = t.torrentHash;
		if (torrentName.size() > 12){
			shortName.assign(torrentName, 0, 12);
			shortName += "...";
			setLabel(shortName);
		}
		else
			setLabel(torrentName);
	}
	return *this;
}

bool TorrentInfoTab::operator==(const TorrentInfoTab &t) const{
	return (torrentHash == t.torrentHash);
}

bool TorrentInfoTab::operator==(const Glib::ustring &c) const{
	return torrentName == c;
}

bool TorrentInfoTab::operator==(const libtorrent::sha1_hash & sh) const{
	return (torrentHash == sh);
}

void TorrentInfoTab::sendBanMessageToNoteBookManager(Glib::ustring &ban_data, int ban_time){
	nb->banClient(ban_data, ban_time);
}

TorrentInfoTab::~TorrentInfoTab(){
}
